Show / Hide Table of Contents

Interface CfnHealthCheck.IHealthCheckConfigProperty

A complex type that contains information about the health check.

Namespace: Amazon.CDK.AWS.Route53
Assembly: Amazon.CDK.Lib.dll
Syntax (csharp)
public interface CfnHealthCheck.IHealthCheckConfigProperty
Syntax (vb)
Public Interface CfnHealthCheck.IHealthCheckConfigProperty
Remarks

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html

ExampleMetadata: fixture=_generated

Examples
// The code below shows an example of how to instantiate this type.
             // The values are placeholders you should change.
             using Amazon.CDK.AWS.Route53;

             var healthCheckConfigProperty = new HealthCheckConfigProperty {
                 Type = "type",

                 // the properties below are optional
                 AlarmIdentifier = new AlarmIdentifierProperty {
                     Name = "name",
                     Region = "region"
                 },
                 ChildHealthChecks = new [] { "childHealthChecks" },
                 EnableSni = false,
                 FailureThreshold = 123,
                 FullyQualifiedDomainName = "fullyQualifiedDomainName",
                 HealthThreshold = 123,
                 InsufficientDataHealthStatus = "insufficientDataHealthStatus",
                 Inverted = false,
                 IpAddress = "ipAddress",
                 MeasureLatency = false,
                 Port = 123,
                 Regions = new [] { "regions" },
                 RequestInterval = 123,
                 ResourcePath = "resourcePath",
                 RoutingControlArn = "routingControlArn",
                 SearchString = "searchString"
             };

Synopsis

Properties

AlarmIdentifier

A complex type that identifies the CloudWatch alarm that you want Amazon Route 53 health checkers to use to determine whether the specified health check is healthy.

ChildHealthChecks

(CALCULATED Health Checks Only) A complex type that contains one ChildHealthCheck element for each health check that you want to associate with a CALCULATED health check.

EnableSni

Specify whether you want Amazon Route 53 to send the value of FullyQualifiedDomainName to the endpoint in the client_hello message during TLS negotiation.

FailureThreshold

The number of consecutive health checks that an endpoint must pass or fail for Amazon Route 53 to change the current status of the endpoint from unhealthy to healthy or vice versa.

FullyQualifiedDomainName

Amazon Route 53 behavior depends on whether you specify a value for IPAddress .

HealthThreshold

The number of child health checks that are associated with a CALCULATED health check that Amazon Route 53 must consider healthy for the CALCULATED health check to be considered healthy.

InsufficientDataHealthStatus

When CloudWatch has insufficient data about the metric to determine the alarm state, the status that you want Amazon Route 53 to assign to the health check: - Healthy : Route 53 considers the health check to be healthy.

Inverted

Specify whether you want Amazon Route 53 to invert the status of a health check, for example, to consider a health check unhealthy when it otherwise would be considered healthy.

IpAddress

The IPv4 or IPv6 IP address of the endpoint that you want Amazon Route 53 to perform health checks on.

MeasureLatency

Specify whether you want Amazon Route 53 to measure the latency between health checkers in multiple AWS regions and your endpoint, and to display CloudWatch latency graphs on the Health Checks page in the Route 53 console.

Port

The port on the endpoint that you want Amazon Route 53 to perform health checks on.

Regions

A complex type that contains one Region element for each region from which you want Amazon Route 53 health checkers to check the specified endpoint.

RequestInterval

The number of seconds between the time that Amazon Route 53 gets a response from your endpoint and the time that it sends the next health check request.

ResourcePath

The path, if any, that you want Amazon Route 53 to request when performing health checks.

RoutingControlArn

The Amazon Resource Name (ARN) for the Route 53 Application Recovery Controller routing control.

SearchString

If the value of Type is HTTP_STR_MATCH or HTTPS_STR_MATCH , the string that you want Amazon Route 53 to search for in the response body from the specified resource.

Type

The type of health check that you want to create, which indicates how Amazon Route 53 determines whether an endpoint is healthy.

Properties

AlarmIdentifier

A complex type that identifies the CloudWatch alarm that you want Amazon Route 53 health checkers to use to determine whether the specified health check is healthy.

object? AlarmIdentifier { get; }
Property Value

object

Remarks

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-alarmidentifier

Type union: either IResolvable or CfnHealthCheck.IAlarmIdentifierProperty

ChildHealthChecks

(CALCULATED Health Checks Only) A complex type that contains one ChildHealthCheck element for each health check that you want to associate with a CALCULATED health check.

string[]? ChildHealthChecks { get; }
Property Value

string[]

Remarks

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-childhealthchecks

EnableSni

Specify whether you want Amazon Route 53 to send the value of FullyQualifiedDomainName to the endpoint in the client_hello message during TLS negotiation.

object? EnableSni { get; }
Property Value

object

Remarks

This allows the endpoint to respond to HTTPS health check requests with the applicable SSL/TLS certificate.

Some endpoints require that HTTPS requests include the host name in the client_hello message. If you don't enable SNI, the status of the health check will be SSL alert handshake_failure . A health check can also have that status for other reasons. If SNI is enabled and you're still getting the error, check the SSL/TLS configuration on your endpoint and confirm that your certificate is valid.

The SSL/TLS certificate on your endpoint includes a domain name in the Common Name field and possibly several more in the Subject Alternative Names field. One of the domain names in the certificate should match the value that you specify for FullyQualifiedDomainName . If the endpoint responds to the client_hello message with a certificate that does not include the domain name that you specified in FullyQualifiedDomainName , a health checker will retry the handshake. In the second attempt, the health checker will omit FullyQualifiedDomainName from the client_hello message.

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-enablesni

Type union: either bool or IResolvable

FailureThreshold

The number of consecutive health checks that an endpoint must pass or fail for Amazon Route 53 to change the current status of the endpoint from unhealthy to healthy or vice versa.

double? FailureThreshold { get; }
Property Value

double?

Remarks

For more information, see How Amazon Route 53 Determines Whether an Endpoint Is Healthy in the Amazon Route 53 Developer Guide .

FailureThreshold is not supported when you specify a value for Type of RECOVERY_CONTROL .

Otherwise, if you don't specify a value for FailureThreshold , the default value is three health checks.

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-failurethreshold

FullyQualifiedDomainName

Amazon Route 53 behavior depends on whether you specify a value for IPAddress .

string? FullyQualifiedDomainName { get; }
Property Value

string

Remarks

If you specify a value for IPAddress :

Amazon Route 53 sends health check requests to the specified IPv4 or IPv6 address and passes the value of FullyQualifiedDomainName in the Host header for all health checks except TCP health checks. This is typically the fully qualified DNS name of the endpoint on which you want Route 53 to perform health checks.

When Route 53 checks the health of an endpoint, here is how it constructs the Host header:

    If you don't specify a value for FullyQualifiedDomainName , Route 53 substitutes the value of IPAddress in the Host header in each of the preceding cases.

    If you don't specify a value for IPAddress :

    Route 53 sends a DNS request to the domain that you specify for FullyQualifiedDomainName at the interval that you specify for RequestInterval . Using an IPv4 address that DNS returns, Route 53 then checks the health of the endpoint.

    If you don't specify a value for <code>IPAddress</code> , Route 53 uses only IPv4 to send health checks to the endpoint. If there's no record with a type of A for the name that you specify for <code>FullyQualifiedDomainName</code> , the health check fails with a "DNS resolution failed" error.
    

    If you want to check the health of multiple records that have the same name and type, such as multiple weighted records, and if you choose to specify the endpoint only by FullyQualifiedDomainName , we recommend that you create a separate health check for each endpoint. For example, create a health check for each HTTP server that is serving content for www.example.com. For the value of FullyQualifiedDomainName , specify the domain name of the server (such as us-east-2-www.example.com), not the name of the records (www.example.com).

    In this configuration, if you create a health check for which the value of <code>FullyQualifiedDomainName</code> matches the name of the records and you then associate the health check with those records, health check results will be unpredictable.
    

    In addition, if the value that you specify for Type is HTTP , HTTPS , HTTP_STR_MATCH , or HTTPS_STR_MATCH , Route 53 passes the value of FullyQualifiedDomainName in the Host header, as it does when you specify a value for IPAddress . If the value of Type is TCP , Route 53 doesn't pass a Host header.

    See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-fullyqualifieddomainname

    HealthThreshold

    The number of child health checks that are associated with a CALCULATED health check that Amazon Route 53 must consider healthy for the CALCULATED health check to be considered healthy.

    double? HealthThreshold { get; }
    Property Value

    double?

    Remarks

    To specify the child health checks that you want to associate with a CALCULATED health check, use the ChildHealthChecks element.

    Note the following:

      See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-healththreshold

      InsufficientDataHealthStatus

      When CloudWatch has insufficient data about the metric to determine the alarm state, the status that you want Amazon Route 53 to assign to the health check: - Healthy : Route 53 considers the health check to be healthy.

      string? InsufficientDataHealthStatus { get; }
      Property Value

      string

      Remarks

        See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-insufficientdatahealthstatus

        Inverted

        Specify whether you want Amazon Route 53 to invert the status of a health check, for example, to consider a health check unhealthy when it otherwise would be considered healthy.

        object? Inverted { get; }
        Property Value

        object

        Remarks

        See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-inverted

        Type union: either bool or IResolvable

        IpAddress

        The IPv4 or IPv6 IP address of the endpoint that you want Amazon Route 53 to perform health checks on.

        string? IpAddress { get; }
        Property Value

        string

        Remarks

        If you don't specify a value for IPAddress , Route 53 sends a DNS request to resolve the domain name that you specify in FullyQualifiedDomainName at the interval that you specify in RequestInterval . Using an IP address returned by DNS, Route 53 then checks the health of the endpoint.

        Use one of the following formats for the value of IPAddress :

          If the endpoint is an EC2 instance, we recommend that you create an Elastic IP address, associate it with your EC2 instance, and specify the Elastic IP address for IPAddress . This ensures that the IP address of your instance will never change.

          For more information, see FullyQualifiedDomainName .

          Constraints: Route 53 can't check the health of endpoints for which the IP address is in local, private, non-routable, or multicast ranges. For more information about IP addresses for which you can't create health checks, see the following documents:

            When the value of Type is CALCULATED or CLOUDWATCH_METRIC , omit IPAddress .

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-ipaddress

            MeasureLatency

            Specify whether you want Amazon Route 53 to measure the latency between health checkers in multiple AWS regions and your endpoint, and to display CloudWatch latency graphs on the Health Checks page in the Route 53 console.

            object? MeasureLatency { get; }
            Property Value

            object

            Remarks

            MeasureLatency is not supported when you specify a value for Type of RECOVERY_CONTROL .

            You can't change the value of <code>MeasureLatency</code> after you create a health check.
            

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-measurelatency

            Type union: either bool or IResolvable

            Port

            The port on the endpoint that you want Amazon Route 53 to perform health checks on.

            double? Port { get; }
            Property Value

            double?

            Remarks
            Don't specify a value for <code>Port</code> when you specify a value for <a href="https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-type">Type</a> of <code>CLOUDWATCH_METRIC</code> or <code>CALCULATED</code> .
            

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-port

            Regions

            A complex type that contains one Region element for each region from which you want Amazon Route 53 health checkers to check the specified endpoint.

            string[]? Regions { get; }
            Property Value

            string[]

            Remarks

            If you don't specify any regions, Route 53 health checkers automatically performs checks from all of the regions that are listed under Valid Values .

            If you update a health check to remove a region that has been performing health checks, Route 53 will briefly continue to perform checks from that region to ensure that some health checkers are always checking the endpoint (for example, if you replace three regions with four different regions).

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-regions

            RequestInterval

            The number of seconds between the time that Amazon Route 53 gets a response from your endpoint and the time that it sends the next health check request.

            double? RequestInterval { get; }
            Property Value

            double?

            Remarks

            Each Route 53 health checker makes requests at this interval.

            RequestInterval is not supported when you specify a value for Type of RECOVERY_CONTROL .

            You can't change the value of <code>RequestInterval</code> after you create a health check.
            

            If you don't specify a value for RequestInterval , the default value is 30 seconds.

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-requestinterval

            ResourcePath

            The path, if any, that you want Amazon Route 53 to request when performing health checks.

            string? ResourcePath { get; }
            Property Value

            string

            Remarks

            The path can be any value for which your endpoint will return an HTTP status code of 2xx or 3xx when the endpoint is healthy, for example, the file /docs/route53-health-check.html. You can also include query string parameters, for example, /welcome.html?language=jp&login=y .

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-resourcepath

            RoutingControlArn

            The Amazon Resource Name (ARN) for the Route 53 Application Recovery Controller routing control.

            string? RoutingControlArn { get; }
            Property Value

            string

            Remarks

            For more information about Route 53 Application Recovery Controller, see Route 53 Application Recovery Controller Developer Guide. .

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-routingcontrolarn

            SearchString

            If the value of Type is HTTP_STR_MATCH or HTTPS_STR_MATCH , the string that you want Amazon Route 53 to search for in the response body from the specified resource.

            string? SearchString { get; }
            Property Value

            string

            Remarks

            If the string appears in the response body, Route 53 considers the resource healthy.

            Route 53 considers case when searching for SearchString in the response body.

            See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-searchstring

            Type

            The type of health check that you want to create, which indicates how Amazon Route 53 determines whether an endpoint is healthy.

            string Type { get; }
            Property Value

            string

            Remarks
            You can't change the value of <code>Type</code> after you create a health check.
            

            You can create the following types of health checks:

              If you specify <code>HTTPS</code> for the value of <code>Type</code> , the endpoint must support TLS v1.0 or later.
              
                Route 53 supports CloudWatch alarms with the following features:
                

                    For more information, see How Route 53 Determines Whether an Endpoint Is Healthy in the Amazon Route 53 Developer Guide .

                    See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-route53-healthcheck-healthcheckconfig.html#cfn-route53-healthcheck-healthcheckconfig-type

                    Back to top Generated by DocFX